function getPooledRequest(countMin,countMax,timeLive)
{
  if (pollOfRequest.length<=countMin) currentIndexOfRequest=++currentIndexOfRequest%countMin;
  else currentIndexOfRequest=++currentIndexOfRequest%pollOfRequest.length;

  if (currentIndexOfRequest >= pollOfRequest.length)
  {
	pollOfRequest[currentIndexOfRequest] ={
		request:new (window.XMLHttpRequest||ActiveXObject)("Msxml2.XMLHTTP"),
		callback:myCallbackFunction(),
		timeReuse:(new Date()).getTime()+timeLive*1000,
		ready:1
	};
	pollOfRequest[currentIndexOfRequest].callback.request=pollOfRequest[currentIndexOfRequest];
	return pollOfRequest[currentIndexOfRequest];
  }

  var saveRequest;

  for (var c=0;c<pollOfRequest.length;c++){
	saveRequest=(currentIndexOfRequest+c)%pollOfRequest.length
	if (++(pollOfRequest[saveRequest].ready)==1 
			|| pollOfRequest[saveRequest].timeReuse<(new Date()).getTime()){
		currentIndexOfRequest=saveRequest;
		pollOfRequest[currentIndexOfRequest].timeReuse=(new Date()).getTime()+timeLive*1000;
		pollOfRequest[currentIndexOfRequest].callback.request=pollOfRequest[currentIndexOfRequest];
		return pollOfRequest[currentIndexOfRequest];
	}	
  }


  if (pollOfRequest.length<countMax){
	currentIndexOfRequest=pollOfRequest.length
	pollOfRequest[currentIndexOfRequest] ={
		request:new (window.XMLHttpRequest||ActiveXObject)("Msxml2.XMLHTTP"),
		callback:myCallbackFunction(),
		timeReuse:(new Date()).getTime()+timeLive*1000,
		ready:1
	};
	pollOfRequest[currentIndexOfRequest].callback.request=pollOfRequest[currentIndexOfRequest];
	return pollOfRequest[currentIndexOfRequest];
  }


  for (var c=0,t=(new Date()).getTime();(new Date()).getTime()-t<timeLive*1000+1000;c++){

   try{
	saveRequest=(currentIndexOfRequest+c)%pollOfRequest.length
	if (++(pollOfRequest[saveRequest].ready)==1 || pollOfRequest[saveRequest].timeReuse-(new Date()).getTime()<0){
		currentIndexOfRequest=saveRequest;
		pollOfRequest[currentIndexOfRequest].request.abort();
		pollOfRequest[currentIndexOfRequest].ready=1;
		pollOfRequest[currentIndexOfRequest].timeReuse=(new Date()).getTime()+timeLive*1000;
		pollOfRequest[currentIndexOfRequest].callback.request=pollOfRequest[currentIndexOfRequest];
		return pollOfRequest[currentIndexOfRequest];
	}
      }catch(e){}
  }

  return;
}


function sendRequest(url,method,callback,onerror,callbackArgsArray)
{
  sendRequest0(url,method,callback,onerror,callbackArgsArray);

}

function sendRequest0(url,method,callback,onerror,callbackArgsArray)
{

  var fcall;
  var ferror;

  fcall=callback;
  ferror=onerror;

  var req=null;
  var request=null;

  requestQueue[requestQueue.length]={url:url,method:method,fcall:fcall,ferror:ferror,callbackArgsArray:callbackArgsArray}

  if (requestQueue.length < 1) return;

  try 
  {
    request = getPooledRequest(4,8,60*10);
    req=request.request;
    url=requestQueue[0].url;
    method=requestQueue[0].method;
    fcall=requestQueue[0].fcall;
    ferror=requestQueue[0].ferror;
    args=requestQueue[0].callbackArgsArray;
    requestQueue.shift();

    req.onreadystatechange=request.callback;
    request.callback.req=req;
    request.callback.method=method;
    request.callback.fcall=fcall;
    request.callback.ferror=ferror;
    request.callback.callbackArgsArray=args;
    request.callback.request=request;

    req.open(method,url,true);
    req.send(null);

  }
  catch(error)
  {
    if (request)
      request.ready=0;
    req.abort();

    setTimeout(function(){sendRequest0()},10+requestQueue.length*10);

    return;
  }
}


var myCallbackFunction=function(req,method,fcall,ferror,callbackArgsArray)
{
  return function()
  {  
    var self;
    if (req) self={req:req,method:method,fcall:fcall,ferror:ferror,callbackArgsArray:callbackArgsArray,request:arguments.callee.request}
    else self=arguments.callee;

    if(self.req.readyState == 4)
    {
      self.req.onreadystatechange = null;

      callbackArgsArray=self.callbackArgsArray;



      for(i=0;i<2;i++)
        if ((contentArray[i])&&(contentArray[i][0]==callbackArgsArray[0])) 
        { 
          contentArray[i][1]=0;
          var masElement=i;
        }

      if (callbackArgsArray[0]=="townList") masElement=2;
      if (callbackArgsArray[0]=="countryList") masElement=3;


      try
      {
        if(self.req.status == 200)
        {
           if (self.method=="HEAD")
           {
             if (lastNewsLength!=self.req.getResponseHeader("Content-Length"))
             { 
               lastNewsLength=self.req.getResponseHeader("Content-Length");
               clTimer(updateNewsTimer);
	       getNewsContent(); 
             }
           }
           else
           {
            callbackArgsArray[1]=self.req;
            callbackArgsArray[2]=masElement;
            self.fcall.apply(fillContentArray,callbackArgsArray);
            if (contentArray[masElement]) contentArray[masElement][1]=1;
           }
        }
        else if (self.method!="HEAD") self.ferror.apply(fError,callbackArgsArray);

      }
      finally
      {
	self.request.ready=0;
	self.req.abort(); 
      }
    }
  }
}

function fillContentArray(rubric,xrequest,masElement)
{

  if (!xrequest.responseXML.documentElement)
  {
    fError(rubric,xrequest,masElement);
    return;
  }

  if (masElement==0) 
  {
    parseXMLFrcContent(xrequest,masElement);
    textLoad.innerHTML="";
    frcLoad.innerHTML="";
    frcText.innerHTML=createFrcGadgetContent();//     
    mapsRubric.innerHTML=showMaps(); 
    bGetFrcContent=false;       
  }

  if (masElement==1) 
  {
    parseXMLNewsContent(xrequest,masElement);
    newsLoad.innerHTML="";
    newsText.innerHTML=showNewsGadgetContent();//      
    bGetNewsContent=false;
    clTimer(updateNewsTimer);
    updateNewsTimer=setTimeout("checkNewsUpdate()",60000*30);    
  }

  if (masElement==2) parseXMLTownsContent(xrequest,masElement);  //      

  if (masElement==3) parseXMLCountriesContent(xrequest,masElement); // 

}

function fError(rubric,xrequest,masElement)
{ 
  dataErrorComplite++; 

  if ((bGetFrcContent)&&(dataErrorComplite==2))
  { 
    if (bGetNewsContent)
    {
    textLoad.innerHTML="<img src='../images/title.png' >";
      //showLoadStatusData("textLoad"," ,     ");
      showLoadStatusData("frcLoad"," ,     ");
      showLoadStatusData("newsLoad"," ,     ");
      clTimer(updateNewsTimer);
      updateNewsTimer=setTimeout("getNewsContent()",5000); 
    }
    else
    {
      //showLoadStatusData("textLoad"," ,     ");
      textLoad.innerHTML="<img src='../images/title.png' >";
      showLoadStatusData("frcLoad"," ,     ");
    }
      
    bGetFrcContent=false;
    bGetNewsContent=false;
    updateGadgetTimer=setTimeout("initObjGadget()",5000);
  }
  
  if ((bGetNewsContent)&&(!bGetFrcContent))
  { 
    showLoadStatusData("newsLoad"," ,     "); 
    bGetNewsContent=false;
    clTimer(updateNewsTimer);
    updateNewsTimer=setTimeout("checkNewsUpdate()",5000);
  }

  if (bGetTownsListContent)
  {
    initListBoxs("townlist","No connect");
    bGetTownsListContent=false;
  }

  if (bGetCountriesListContent)
  {
    initListBoxs("countrylist","No connect");
    bGetCountriesListContent=false;
  }
}


//////////////////////////////////////////////////// XML   ///////////////////////////////////////////////////////////


function parseXMLFrcContent(xrequest,masElement)
{
  var forecast = xrequest.responseXML.documentElement.getElementsByTagName('FORECAST'); 
  for(i=0; i<forecast.length; i++){
      param = new FrcParam;
      param.day=forecast[i].getAttribute("day");
      param.month=forecast[i].getAttribute("month");
      param.year=forecast[i].getAttribute("year");
      param.weekday=forecast[i].getAttribute("weekday");
      param.period = forecast[i].getAttribute("tod");
      for(j=0; j<forecast[i].childNodes.length; j++)
      {
        if(forecast[i].childNodes(j).nodeType==1)
	{
	  var name=forecast[i].childNodes(j).nodeName;
	  switch (name)
	  {
	    case 'PHENOMENA':
	    {
	      param.cloudiness=forecast[i].childNodes(j).getAttribute("cloudiness");
	      param.precipitation=forecast[i].childNodes(j).getAttribute("precipitation");
     
	    }
	    case 'PRESSURE':
	    {
	      param.pressure=eval(forecast[i].childNodes(j).getAttribute("min"))+eval(forecast[i].childNodes(j).getAttribute("max"));
	    }

	    case 'TEMPERATURE':
	    {
	      //param.temper=eval(forecast[i].childNodes(j).getAttribute("min"))+eval(forecast[i].childNodes(j).getAttribute("max"));
	      var min = forecast[i].childNodes(j).getAttribute("min");
	      var max = forecast[i].childNodes(j).getAttribute("max");
	      if (min>0)
	      	min="+"+min;
	      else
	      	min="-"+min;
          if (max>0)
	      	max="+"+max;
	      else
	      	max="-"+max;

			param.temper=min+".."+max;


	    }
	    case 'WIND':
	    {
	      param.wdir=forecast[i].childNodes(j).getAttribute("direction");
	      param.ws=eval(forecast[i].childNodes(j).getAttribute("min"))+eval(forecast[i].childNodes(j).getAttribute("max"));
	    }
            case 'RELWET':
	    {
	      param.relwet=eval(forecast[i].childNodes(j).getAttribute("min"))+eval(forecast[i].childNodes(j).getAttribute("max"));		   
	    }  
	  }
        }		
      }
      param=createWeatherParam(param);
      contentArray[masElement][i+2]=param;
      delete param;
  }
}

function parseXMLNewsContent(xrequest,masElement)
{
   var newsitem = xrequest.responseXML.documentElement.getElementsByTagName('item');
   for(i=0; i<newsitem.length; i++){
      news = new gNews;
      for(j=0; j<newsitem[i].childNodes.length; j++)
      {
        if(newsitem[i].childNodes(j).nodeType==1)
	{
           var name=newsitem[i].childNodes(j).nodeName;
           switch (name)
           {
	    case 'title':
	    {
	      news.title=newsitem[i].childNodes(j).text;
	    }
	    case 'link':
	    {
	      news.link=newsitem[i].childNodes(j).text;
	    }
	    case 'description':
	    {
	      news.text=newsitem[i].childNodes(j).text;
	    }
	    case 'pubDate':
	    {
	      news.date=newsitem[i].childNodes(j).text;
	    }

           }
        }
      }
      contentArray[masElement][i+2]=news;
      delete news;
   }
}


function createWeatherParam(param) 
{
 if (param.day.length==1) param.day='0'+param.day;
 if (param.month.length==1) param.month='0'+param.month;
 
 param.textdate=param.day+"."+param.month+'.'+param.year;
	
 if ((param.precipitation==4) || (param.precipitation==5))
 {
   if (param.cloudiness==2) { param.pic="4"; param.textcloudiness=imghintArray[4];}
   if (param.cloudiness==3) { param.pic="5"; param.textcloudiness=imghintArray[5];}
 }

 if ((param.precipitation==6) || (param.precipitation==7))
 {
   if (param.cloudiness==2) { param.pic="6"; param.textcloudiness=imghintArray[6];}
   if (param.cloudiness==3) { param.pic="7"; param.textcloudiness=imghintArray[7];}
 }

 if (param.precipitation==8){ param.pic="8"; param.textcloudiness=imghintArray[8];}
 
 if (param.precipitation==10) 
 {
   if (param.cloudiness==0) param.pic="0";
   if (param.cloudiness==1) param.pic="1";
   if (param.cloudiness==2) param.pic="2";
   if (param.cloudiness==3) param.pic="3";
   param.textcloudiness=imghintArray[+(param.cloudiness)];			
 }

 //if (param.temper>0) param.temper="+"+param.temper;
 param.temper=param.temper+"&deg;";
	
 param.pressure=Math.round(param.pressure / 2);	

 return param;			
	
}
