﻿var GismetSetting = new gismeteoSettings();

System.Gadget.onSettingsClosing = SettingsClosing;


function loadGismeteoSettings()
{
  GismetSetting.load();
  if (townlist.options.length==0) 
  {
    initListBoxs("townlist","Идёт загрузка...");
    GismetSetting.getTownsLists();
  }
  if (countrylist.options.length==0) 
  {
    initListBoxs("countrylist","Идёт загрузка...");
    GismetSetting.getCountriesLists();
  }
}

function gismeteoSettings()
{
  this.tlistarray=new Array();
  this.tlistarray['townName']=new Array();
  this.tlistarray['townIndex']=new Array();
  this.tlistarray['countryName']=new Array();

  this.load=gismeteoLoadSettings;
  this.getTownsLists=gismeteoGetTownsLists;
  this.getCountriesLists=gismeteoGetCountriesLists;	
  this.save=gismeteoSaveSettings;		
}


function gismeteoLoadSettings()
{
  this.countryName="Украина";
  this.townIndex="33345";
  this.townName="Киев";

  if (System.Gadget.Settings.read("SettingsExist"))
  {
    this.countryName = unescape(System.Gadget.Settings.readString("countryName"));
    this.townIndex = parseInt(System.Gadget.Settings.read("townIndex"));
    this.townName = System.Gadget.Settings.read("townName");
  }

}

function gismeteoSaveSettings()
{
  System.Gadget.Settings.write("SettingsExist", true);
  System.Gadget.Settings.write("countryName",this.countryName);
  System.Gadget.Settings.write("townName",this.townName);
  System.Gadget.Settings.write("townIndex",this.townIndex);
}


function gismeteoGetTownsLists()
{ 
  bGetTownsListContent=true;

  if (townlist.options.length==1)
  {
    var r=Math.random();
    sendRequest(LinksArray[2]+"?r="+r, "GET", fillContentArray, fError,new Array("townList"));
  }  
}

function gismeteoGetCountriesLists()
{ 
  bGetCountriesListContent=true;

  if (countrylist.options.length==1)
  {
    var r=Math.random();
    sendRequest(LinksArray[3]+"?r="+r, "GET", fillContentArray, fError,new Array("countryList"));
  }  
}



function parseXMLTownsContent(xrequest,masElement)
{
  var listrecords=xrequest.responseXML.documentElement.getElementsByTagName('t');
  for (i=1; i<listrecords.length;i++)
  {
    GismetSetting.tlistarray['townName'][i-1]=listrecords[i].getAttribute("n");
    GismetSetting.tlistarray['townIndex'][i-1]=listrecords[i].getAttribute("i");
    GismetSetting.tlistarray['countryName'][i-1]=listrecords[i].getAttribute("c"); 		
  }

  showTownList();
  
}

function parseXMLCountriesContent(xrequest,masElement)
{
  var currentIndex=0;
  countrylist.options.length=0;
  var listrecords=xrequest.responseXML.documentElement.getElementsByTagName('c');
  if (listrecords) 
  {
    countrylist.options.length=0;
    for (i=1; i<listrecords.length;i++)
    {
      var newOption = document.createElement("OPTION");
      newOption.value = listrecords[i].getAttribute("n");
      newOption.text = listrecords[i].getAttribute("n");

      if (newOption.text==GismetSetting.countryName) currentIndex=i-1;
      countrylist.options[countrylist.options.length] = newOption;
      newOption = null;
    }
    countrylist.selectedIndex=currentIndex;		
  }
  else countrylist.options[0]="Нет данных";
}


function showTownList()
{
   var index=0;
   var j=0;
   townlist.options.length=0; 

   if (GismetSetting.tlistarray['townName'].length>=1) {		
     for(i=1;i<=GismetSetting.tlistarray['townName'].length;i++){
       if (GismetSetting.tlistarray['countryName'][i]==GismetSetting.countryName){
	 var newOption = document.createElement("OPTION");
	 newOption.value = GismetSetting.tlistarray['townIndex'][i]+GismetSetting.tlistarray['townName'][i];
	 newOption.text = GismetSetting.tlistarray['townName'][i];

	 if (newOption.text==GismetSetting.townName) index=j;

	 townlist.options[townlist.options.length] = newOption;
	 newOption = null; 
	 j++;

       }
     }
   townlist.selectedIndex=index;
   }

}

function SettingsClosing(event)
{

  if ((townlist.options.length==0)&&(countrylist.options.length==0)) return;
  if (countrylist.options[countrylist.selectedIndex].text=="Нет данных") return;
  if (townlist.options[townlist.selectedIndex].text=="Нет данных") return;
  if (countrylist.options[countrylist.selectedIndex].text=="Идёт загрузка...") return;
  if (townlist.options[townlist.selectedIndex].text=="Идёт загрузка...") return;


 	if (event.closeAction == event.Action.commit) {
		GismetSetting.countryName=countrylist.options[countrylist.selectedIndex].text;
		GismetSetting.townName=townlist.options[townlist.selectedIndex].text;
		GismetSetting.townIndex=townlist.options[townlist.selectedIndex].value;
		GismetSetting.save();
	}
	event.cancel = false;
}

function initListBoxs(strObj,str)
{
  var obj=document.getElementById(strObj);
  if (obj)
  {
    obj.options.length=0;
    var newOption = document.createElement("OPTION");
    if (str=="No connect") str="Нет данных";
    newOption.text=str;
    obj.options[obj.options.length]=newOption;
    newOption = null; 
  }
}